% Testing functionality and correctness of all the variants of transform
% This is not test against the Matlab Wavelet toolbox

clc
load data


%% orthogonal
signal = sig7;
par = parity(length(signal));
[A_db3,D_db3] = sldwt(signal,Lo_D_db3,Hi_D_db3,0);
n_coefs = n_coef(length(signal),length(Lo_D_db3),1)
n_coefs_total = n_coef_total(length(signal),length(Lo_D_db3),1)
recon = slidwt(A_db3,D_db3,Lo_R_db3,Hi_R_db3,par,0);
input_output_difference = norm(signal-recon) % test
%length(signal) == length()
%pause

signal = sig6;
par = parity(length(signal));
[A_db3,D_db3] = sldwt(signal,Lo_D_db3,Hi_D_db3,0);
recon = slidwt(A_db3,D_db3,Lo_R_db3,Hi_R_db3,par,0);
norm(signal-recon) % test
%pause

signal = sig7;
par = parity(length(signal));
[A_db3,D_db3] = sldwt(signal,Lo_D_db3,Hi_D_db3,1);
recon = slidwt(A_db3,D_db3,Lo_R_db3,Hi_R_db3,par,1);
norm(signal-recon) % test
%pause

signal = sig6;
par = parity(length(signal));
[A_db3,D_db3] = sldwt(signal,Lo_D_db3,Hi_D_db3,1);
recon = slidwt(A_db3,D_db3,Lo_R_db3,Hi_R_db3,par,1);
norm(signal-recon) % test
%pause


%% bior
signal=sig7;
par=parity(length(signal));
[A,D] = sldwt(signal,Lo_Dshort,Hi_Dshort,0);
recon = slidwt(A,D,Lo_Rshort,Hi_Rshort,par,0);
norm(signal-recon) % test
%pause

signal=sig6;
par=parity(length(signal));
[A,D] = sldwt(signal,Lo_Dshort,Hi_Dshort,0);
recon = slidwt(A,D,Lo_Rshort,Hi_Rshort,par,0);
norm(signal-recon) % test
%pause

signal=sig7;
par=parity(length(signal));
[A,D] = sldwt(signal,Lo_Dshort,Hi_Dshort,1);
recon = slidwt(A,D,Lo_Rshort,Hi_Rshort,par,1);
norm(signal-recon) % test
%pause

signal=sig6;
par=parity(length(signal));
[A,D] = sldwt(signal,Lo_Dshort,Hi_Dshort,1);
recon = slidwt(A,D,Lo_Rshort,Hi_Rshort,par,1);
norm(signal-recon) % test
