function num = n_affect_l(depth, fillen)

% N_AFFECT_L returns the number of left-side coefficients that are affected
% by the boundary handling
%
% depth........depth of decomposition
% fillen.......length of filter
%
% num..........number of the affected coefficients

%(c) 2012 Pavel Rajmic, Brno University of Technology, Czech Republic


num = (1-2^(-depth))*(fillen-1);
num = floor(num);