function num = n_shift(k1, k2, depth)

% N_SHIFT returns the shift in terms of signal samples for wavelet coefficients 
%
% k1, k2.......indices of the wavelet coefficients (k1<k2)
% depth........depth of decomposition
%
% num..........number of samples of shift in the time-domain

%(c) 2010-12 Pavel Rajmic, Brno University of Technology, Czech Republic


num = 2^depth*(k2-k1);