function [minindex, maxindex] = ran(k,j,u,fillen)

% RAN computes the range of influence of a coefficient
%
% k.............index of the coefficient within its vector from level j
% j.............starting level
% u.............target level, j>=u
% 
% minindex, maxindex......the range

%(c) 2010-12 Pavel Rajmic, Brno University of Technology, Czech Republic


maxindex = 2^(j-u)*k;
minindex = maxindex - (2^(j-u)-1)*(fillen-1);